package kaysaar.aotd_question_of_loyalty.data.scripts;

import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionDataManager;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.campaign.econ.MonthlyReport;
import com.fs.starfarer.api.impl.campaign.shared.SharedData;
import kaysaar.aotd_question_of_loyalty.data.plugins.AoTDNexMarketUtil;
import com.fs.starfarer.api.impl.campaign.rulecmd.AoTDRetirementOption;
import com.fs.starfarer.api.Global;
import kaysaar.aotd_question_of_loyalty.data.models.RetirementInfo;
import com.fs.starfarer.api.campaign.listeners.EconomyTickListener;

public class AoTDPensionFund implements EconomyTickListener
{
    protected RetirementInfo info;
    
    public AoTDPensionFund(final String factionId, final float assignedPension, final String prevRankId) {
        this.info = new RetirementInfo(prevRankId, assignedPension, factionId);
        Global.getSector().getMemory().set(AoTDRetirementOption.memKey, (Object)this.info);
        Global.getSector().getListenerManager().addListener((Object)this);
    }
    
    public void reportEconomyTick(final int iterIndex) {
        if (AoTDNexMarketUtil.doesPlayerHaveMarkets(true)) {
            Global.getSector().getListenerManager().removeListener((Object)this);
            return;
        }
        final float numIter = Global.getSettings().getFloat("economyIterPerMonth");
        final float f = 1.0f / numIter;
        final MonthlyReport report = SharedData.getData().getCurrentReport();
        final MonthlyReport.FDNode fleetNode = report.getNode(new String[] { MonthlyReport.FLEET });
        fleetNode.name = "Fleet";
        fleetNode.custom = MonthlyReport.FLEET;
        fleetNode.tooltipCreator = (TooltipMakerAPI.TooltipCreator)report.getMonthlyReportTooltip();
        final FactionAPI faction = Global.getSector().getFaction(this.info.getPrevFaction());
        final float stipend = this.info.getSalary();
        final MonthlyReport.FDNode node;
        final MonthlyReport.FDNode stipendNode = node = report.getNode(fleetNode, new String[] { "node_id_pension_" + this.info.getPrevFaction() });
        node.income += stipend * f;
        if (stipendNode.name == null) {
            stipendNode.name = faction.getDisplayName() + " Retirement pension";
            stipendNode.icon = faction.getCrest();
            stipendNode.tooltipCreator = (TooltipMakerAPI.TooltipCreator)new TooltipMakerAPI.TooltipCreator() {
                public boolean isTooltipExpandable(final Object tooltipParam) {
                    return false;
                }
                
                public float getTooltipWidth(final Object tooltipParam) {
                    return 450.0f;
                }
                
                public void createTooltip(final TooltipMakerAPI tooltip, final boolean expanded, final Object tooltipParam) {
                    tooltip.addPara("Your monthly retirement pension, for serving  " + faction.getDisplayName() + " as " + AoTDCommissionDataManager.getInstance().getRank(AoTDPensionFund.this.info.getPrevRankId()).getName(), 0.0f);
                }
            };
        }
    }
    
    public void reportEconomyMonthEnd() {
    }
}
